// MySDI01View.cpp : implementation of the CMySDI01View class
//

#include "stdafx.h"
#include "MySDI01.h"

#include "MySDI01Doc.h"
#include "MySDI01View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMySDI01View

IMPLEMENT_DYNCREATE(CMySDI01View, CView)

BEGIN_MESSAGE_MAP(CMySDI01View, CView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CView::OnFilePrintPreview)
  ON_COMMAND(ID_RUN_RANDOM, &CMySDI01View::OnRunRandom)
  ON_COMMAND(ID_RUN_SORT, &CMySDI01View::OnRunSort)
  ON_COMMAND(ID_RUN_SORT32773, &CMySDI01View::OnRunSort_b)
END_MESSAGE_MAP()

// CMySDI01View construction/destruction

CMySDI01View::CMySDI01View()
{
	// TODO: add construction code here

}

CMySDI01View::~CMySDI01View()
{
}

BOOL CMySDI01View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CMySDI01View drawing

void CMySDI01View::OnDraw(CDC* /*pDC*/)
{
	CMySDI01Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: add draw code for native data here
}


// CMySDI01View printing

BOOL CMySDI01View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CMySDI01View::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CMySDI01View::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CMySDI01View diagnostics

#ifdef _DEBUG
void CMySDI01View::AssertValid() const
{
	CView::AssertValid();
}

void CMySDI01View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMySDI01Doc* CMySDI01View::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMySDI01Doc)));
	return (CMySDI01Doc*)m_pDocument;
}
#endif //_DEBUG


class CMy
{
public:
  int age;
  CString txt;
  CMy()
  {
    age = rand()%1000;
    txt = "-";
    for(int n=3; n<9; n++) txt += char(rand()%256-128);
  }
};
int swp(CMy& x, CMy& y)
{
  CMy z;
  z.age=x.age;
  z.txt=x.txt;
  x.age=y.age;
  x.txt=y.txt;
  y.age=z.age;
  y.txt=z.txt;
  return true;
}
const int N=10;
CMy cm[N];

// CMySDI01View message handlers

  int x=5, y=5;
void CMySDI01View::OnRunRandom()
{
  // TODO: Add your command handler code here
  AfxMessageBox("Random");
  CDC* pdc = GetDC();
  RECT r;
  GetClientRect(&r);
  pdc->Ellipse(&r);
  for(int n=0; n<N; n++)
  {
    char buf[256];
    sprintf(buf, "[%02d] age=%04d %s", n, cm[n].age, cm[n].txt);
    pdc->TextOut(x, y, buf);
    y += 20;
  }
}

void CMySDI01View::OnRunSort()
{
  // TODO: Add your command handler code here
  AfxMessageBox("Sort-a");
  CDC* pdc = GetDC();
  RECT r;
  GetClientRect(&r);
  for(int n=0; n<N-1; n++)
  for(int m=n+1; m<N; m++)
  {
    if(cm[n].age<cm[m].age)
      swp(cm[n], cm[m]);
  }
  x += 150;
  y = 5;
  for(int n=0; n<N; n++)
  {
    char buf[256];
    sprintf(buf, "[%02d] age=%03d %s", n, cm[n].age, cm[n].txt);
    pdc->TextOut(x, y, buf);
    y += 20;
  }
}



void CMySDI01View::OnRunSort_b()
{
  // TODO: Add your command handler code here
  AfxMessageBox("Sort-b");
  CDC* pdc = GetDC();
  RECT r;
  GetClientRect(&r);
  for(int n=0; n<N-1; n++)
  for(int m=n+1; m<N; m++)
  {
    if(cm[n].age>cm[m].age)
      swp(cm[n], cm[m]);
  }
  x += 150;
  y = 5;
  for(int n=0; n<N; n++)
  {
    char buf[256];
    sprintf(buf, "[%02d] age=%04d %s", n, cm[n].age, cm[n].txt);
    pdc->TextOut(x, y, buf);
    y += 20;
  }
}
